
let MainSTG = GetCurrentScriptDirectory;
let FuncSrc = GetCurrentScriptDirectory;
let DEBUG = true;

#include"./SpellPracticeData.h"

let MENU_BEGIN = -1;
let MENU_START_GAME = 0;
let MENU_START_EXTRA = 1;
let MENU_START_PRACTICE = 2;
let MENU_START_S_PRACTICE = 3;
let MENU_REPLAY = 4;
let MENU_STATS = 5;
let MENU_MUSICROOM = 6;
let MENU_OPTION = 7;
let MENU_MANUAL = 8;
let MENU_EXIT = 9;

let MENU_RETURN_START_GAME = -2;
let MENU_RETURN_START_EXTRA = -3;

let DIFFICULTY_REALVAR = [12, 36, 48, 72, 96, 120];

let Global_LastSelection = [1, 0, 0]; //StartGame, CharSelect, CharMenuSelect

let SpellSource = current~"source/Boss/";
let img_effect = current~"ds_system/img/effect.png"; // Effect Sheet
let img_frame = current~"ds_system/img/frame2.png"; // Effect Sheet

let Font_Main_Path = current~"ds_system/font/GROBOLD.ttf";
let Font_Main_Name = "GROBOLD";
let Font_Main_Modifier = 1.3;

let Font_Sub_Path = current~"ds_system/font/Florida Project Phase Two.ttf";
let Font_Sub_Name = "Florida Project Phase Two";
let Font_Sub_Modifier = 1.2;

let Menu_Title = current~"source/Menu/Title.png";
let Menu_Sub = current~"source/Menu/SubMenu.png";
let Menu_Char = current~"source/Menu/CharSlect.png";
let Menu_Rank = current~"source/Menu/rankselect.png";

let Character_Info = [""];

let TitleBG = ID_INVALID;
let MenuBG = ID_INVALID;
let SubMenus = [];

let CurrentBGM = ID_INVALID;
let CurrentBGMID = "";

let selection = -1;
let lastselection = -1;
let selecthold = 16;

let GlobalSounds = [];
let GlobalSndStr = [];
let ReallyPlaying = [];

let ScriptNames = [[], [], [], [], [], []];
let ScriptIDs = [];

let IsPlayersLoaded = false;
let IsStgFieldActive = false;

let options = [80, 80, 2, 3, 2, 0];
let score;


let Default_OptionData = [options, Global_LastSelection];



task PlaySound(name){
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name~" (Not Found)");}
	ObjSound_SetVolumeRate(GlobalSounds[ID], options[1]);
	ObjSound_Play(GlobalSounds[ID]);
}

task FallingLeafContainer{
	while(!IsStgFieldActive){
		FallingLeafA1(rand(-64,640), rand(-64,480), 196, 196, 196, 0.7);
		loop(5-options[2]){yield;}
	}
}

task FallingLeafA1(deX, deY, colorR, colorG, colorB, deScale){
	if(options[2] == 0){return;}
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	let obj_time = 0;
	let angX = rand(-360, 360);
	let angY = rand(-360, 360);
	let angZ = rand(-360, 360);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.76);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 0, 228, 33, 251);
	ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
	ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
	ObjRender_SetPosition(obj, deX, deY, 0);
	ObjRender_SetColor(obj, colorR, colorG, colorB);
	ObjRender_SetAlpha(obj, 0);
	
	let alpha = 0.1;
	let scale = deScale;
	let randX = rand(50, 350);
	let randY = rand(50, 350);
	let RandZ = rand(17,170);
	//atan2(randY - deX, randX - deY);
	while(obj_time<182&&options[2]>0&&!IsStgFieldActive){
		obj_time++;
		if(obj_time>150){alpha = max(alpha-3, 0)}else{alpha = min(alpha+3, 96)}
		alpha += 0.1;
		deX += randX/250;
		deY += randY/250;
		angX += randX/255;
		angY += randY/255;
		angZ += randX/295+randY/295;
		
		ObjRender_SetPosition(obj, deX, deY, 0);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetAlpha(obj, alpha);
		ObjRender_SetScaleXYZ(obj, scale, scale, scale);
		yield;
	}
	Obj_Delete(obj);
}



task MainMenu(selectmod){
	loop(2){yield;}
	if(selection == MENU_BEGIN){
		if(!InstallFont(Font_Main_Path)){RaiseError("Error when loading: Could not load font "~Font_Main_Path)}
	}
	
	selection = selectmod;
	lastselection = selectmod;
	selecthold = 13;
	let TextObjects = [];
	let TextAlphas = [];
	let TA = 0; //TextAlpha
	let TextNames = ["Game Start", "Extra Start", "Practice Start", "Spell Practice",
	"Replay", "Player Data", "Music Room", "Option", "Information", "Quit"];
	
	let IsAvailable = [1, 0, 0, 1, 0, 0, 1, 1, 0, 1];
	
	let MainCord = [128, 384];
	let SubCords = []; //[[x, y, z, randx, randy]]
	ascent(i in 0..length(TextNames)){
		let locText = DrawSubMenuText(TextNames[i]);
		TextObjects = TextObjects~[locText];
		ObjText_SetHorizontalAlignment(locText, ALIGNMENT_LEFT);
		SubCords = SubCords~[[MainCord[0]-90, MainCord[1]-150+i*16, 0, 0, 0]];
		ObjRender_SetPosition(locText, SubCords[i][0], SubCords[i][1], SubCords[i][2]);
		ObjText_SetMaxWidth(locText, 180);
		ObjText_SetFontSize(locText,12*Font_Main_Modifier);
		ObjText_SetFontType(locText,Font_Main_Name);
		ObjText_SetFontBorderColor(locText,16,16,16);
	}
	
	let OrigCords = SubCords;
	
	if(selection == MENU_BEGIN){
		FallingLeafContainer;
		TitleBG = CreateMenuImage(Menu_Title);
		DisplayFPS;
		let RetreivedOptionsData = GetAreaCommonData("OptionConfig", "Options", Default_OptionData);
		options = RetreivedOptionsData[0];
		Global_LastSelection = RetreivedOptionsData[1];

		score = GetAreaCommonData("Score", "Score", []);
		PlayMusic("00", false);
		
		ascent(i in 0..length(TextObjects)){
			TextAlphas = TextAlphas~[-32*(i+1)];
			if(IsAvailable[i]){ObjRender_SetColor(TextObjects[i], 160, 160, 160)}
			else{ObjRender_SetColor(TextObjects[i], 80, 80, 80)}
		}
		while(TextAlphas[length(TextAlphas)-1]<255){
			ascent(i in 0..length(TextObjects)){
				ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
				TextAlphas[i] = min(TextAlphas[i]+12, 255);
			}
			yield;
		}
		SelectChange(1, 0);
	}else if(selection == MENU_RETURN_START_GAME){
		FallingLeafContainer;
		TitleBG = CreateMenuImage(Menu_Title);
		DisplayFPS;
		PlayMusic("00", true);
		
		ascent(i in 0..length(TextObjects)){
			TextAlphas = TextAlphas~[-32*(i+1)];
			if(IsAvailable[i]){ObjRender_SetColor(TextObjects[i], 160, 160, 160)}
			else{ObjRender_SetColor(TextObjects[i], 80, 80, 80)}
		}
		SelectChange(2, 0);
	}else{
		ReturnToTitle(MenuBG);
	}
	
	loop{
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 13;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				SelectChange(-1, 1);
				PlaySound("se_select00");
				if(selection<-1){
					selection = length(TextObjects)-1;
				}
			}
			selecthold--;
		}else if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 13;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				SelectChange(1, 1);
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = -1;
				}
			}
			selecthold--;
		}else{selecthold = 13;}
		
		ascent(i in 0..length(TextObjects)){
			let LocCord = SubCords[i];

			SubCords[i] = [LocCord[0], LocCord[1], LocCord[2], max(0, LocCord[3]-0.35), 
			max(0, LocCord[4]-0.35)];
			
			ObjRender_SetPosition(TextObjects[i], LocCord[0]+rand(-LocCord[3], LocCord[3]), 
			LocCord[1]+rand(-LocCord[4], LocCord[4]), LocCord[2]);
			
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else if(!IsAvailable[i]){
				ObjRender_SetColor(TextObjects[i], 80, 80, 80);
			}else{
				ObjRender_SetColor(TextObjects[i], 160, 160, 160);
			}
		}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			PlaySound("se_ok00");
			break;
		}
		if(GetVirtualKeyState(VK_BOMB)==KEY_PUSH){
			PlaySound("se_cancel00");
			if(selection!=MENU_EXIT){
				selection = MENU_EXIT;
			}else{
				break;
			}
		}
		yield;
	}
	
	alternative(selection)
	case(MENU_START_GAME){StartGame_Difficulty;} 
	case(MENU_START_EXTRA){}
	case(MENU_START_PRACTICE){}
	case(MENU_START_S_PRACTICE){SpellPractice;}
	case(MENU_REPLAY){}
	case(MENU_STATS){}
	case(MENU_MUSICROOM){MusicRoom;}
	case(MENU_OPTION){SetOptionsMenu;}
	case(MENU_MANUAL){}
	case(MENU_EXIT){EndGame;}
	
	MenuBG = CreateMenuImage(Menu_Sub);
	
	descent(x in 0..14){
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], 255*(x/14));
			ObjRender_SetX(TextObjects[i], ObjRender_GetX(TextObjects[i])-(x/7));
		}
		ObjRender_SetAlpha(MenuBG, 255-255*(x/14));
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		Obj_Delete(TextObjects[i]);
	}
	
	function SelectChange(num, tr){
		if(tr){PlaySound("se_select00");}
		selecthold += 7;
		lastselection = selection;
		selection+=num;
		if(selection<0){selection=length(TextObjects)-1}
		if(selection>=length(TextObjects)){selection=0}
		while(!IsAvailable[selection]){
			selection+=num;
		}
		let rz = SubCords[selection];
		SubCords[selection] = [rz[0], rz[1], rz[2], rz[3], 4.75];
	}
}


task CharacterSelect(type){
	yield;
	LoadAvailablePlayers(false);
	let playercount = GetFreePlayerScriptCount;
	let pinfo = [];
	ascent(i in 0..playercount){
		pinfo = pinfo~[[
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_PATH),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_ID),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_TITLE),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_TEXT),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_IMAGE),
			GetFreePlayerScriptInfo(i, INFO_SCRIPT_REPLAY_NAME),
		]];
	}
	
	selection = SafeAssignA1(Global_LastSelection[1], length(pinfo)-1);
	lastselection = 0;
	selecthold = 16;
	
	let menuselect = SafeAssignA1(Global_LastSelection[2], length(pinfo)-1); //For the scroll effect
	let menucap = 8; // The amount of players shown maximum
	let LocalIsSelecting = true;
	
	let TextObjects = [];
	let TextAlphas = [];
	let Cord = [380, 96];
	
	let TextFontSize = 16*Font_Sub_Modifier;
	ascent(i in 0..length(pinfo)){
		TextObjects = TextObjects~[DrawSubMenuText(pinfo[i][2])];
		ObjText_SetFontSize(TextObjects[i],TextFontSize);
		ObjText_SetHorizontalAlignment(TextObjects[i], ALIGNMENT_LEFT);
		ObjText_SetFontColorTop(TextObjects[i],224,224,224);
		ObjText_SetFontColorBottom(TextObjects[i],96,96,255);
		TextAlphas = TextAlphas~[0];
	}
	CreateNewProfile(pinfo[selection], selection, 1);
	loop{
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
			TextAlphas[i] = min(TextAlphas[i]+10, 255);
			ObjRender_SetPosition(TextObjects[i], Cord[0], Cord[1]-32+(i-menuselect)*TextFontSize, 0);
			Obj_SetVisible(TextObjects[i], true);
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
				if(i-menuselect<0||i-menuselect>menucap-1){
					Obj_SetVisible(TextObjects[i], false);
				}
			}
		}
		
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				MenuMove(-1);
				PlaySound("se_select00");
				if(selection-menuselect<0&&menuselect>0){
					menuselect--;
				}
				if(selection<0){
					selection = length(TextObjects)-1;
					menuselect = length(TextObjects)-min(length(TextObjects), menucap);
				}
				CreateNewProfile(pinfo[selection], selection, 1);
			}
			selecthold--;
		}else
		if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				MenuMove(1);
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = 0;
					menuselect = 0;
				}
				if(selection-menuselect>menucap-1){
					menuselect++;
				}
				CreateNewProfile(pinfo[selection], selection, -1);
			}
			selecthold--;
		}else{selecthold = 16;}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			StartTheGame(type, pinfo[selection]);
			PlaySound("se_ok00");
			break;
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH){
			//StartGame_Difficulty;
			MainMenu(MENU_START_GAME);
			PlaySound("se_cancel00");
			break;
		}
		yield;
	}
	Global_LastSelection[1] = selection;
	Global_LastSelection[2] = menuselect;
	SaveOptionsAreaData;
	LocalIsSelecting = false;
	ascent(i in 0..length(TextObjects)){
		ReturnToTitle(TextObjects[i]);
	}
	yield;	
	
	
	task CreateNewProfile(info, select, mod){
		// path, id, title, text, image, replay name
		
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		let localalpha = 60;
		let img = info[4];
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.74);
		ObjPrim_SetTexture(obj, img);
		ObjSprite2D_SetSourceRect(obj, 0, 0, GetTextureWidth(img)-1, GetTextureHeight(img)-1);
		ObjSprite2D_SetDestRect(obj, -GetTextureWidth(img)/2, 0, GetTextureWidth(img)/2, GetTextureHeight(img));
		ObjRender_SetPosition(obj, GetTextureWidth(img)/2, 0, 0);
		
		
		let objTxt = DrawLocalCommentText(info[3]);
		let objTxtRep = DrawLocalCommentText("Player ID: "~info[1]~"[r]Replay ID: "~info[5]);
		ObjText_SetFontSize(objTxtRep,12*Font_Sub_Modifier);
		
		ObjRender_SetPosition(objTxt, Cord[0]-48, Cord[1]+200, 0);
		ObjRender_SetPosition(objTxtRep, Cord[0]-32, Cord[1]+150, 0);
			
		descent(i in 0..15){
			ObjRender_SetAngleY(obj, 90/15*i);
			localalpha = 255-255/15*i;
			CheckStillActive;
			DoCasualChecks;
			yield;
		}
		
		loop{
			CheckStillActive;
			DoCasualChecks;
			yield;
		}
		
		descent(i in 0..10){
			ObjRender_SetAngleY(obj, 90-90/10*i);
			localalpha = 25.5*i;
			DoCasualChecks;
			yield;
		}
		Obj_Delete(obj);
		Obj_Delete(objTxt);
		Obj_Delete(objTxtRep);
		
		sub CheckStillActive{
			if(!LocalIsSelecting){break;}
			if(selection!=select){break;}
		}
		sub DoCasualChecks{
			ObjRender_SetAlpha(obj, localalpha);
			ObjRender_SetAlpha(objTxt, localalpha);
			ObjRender_SetAlpha(objTxtRep, localalpha);
		}
		
		function DrawLocalCommentText(txtStr){
			let objTxt = ObjText_Create;
			ObjText_SetText(objTxt,txtStr);
			ObjText_SetFontSize(objTxt,15*Font_Sub_Modifier);
			ObjText_SetFontType(objTxt,Font_Sub_Name);
			ObjText_SetFontColorTop(objTxt,224,224,224);
			ObjText_SetFontColorBottom(objTxt,96,96,255);
			ObjText_SetFontBorderType(objTxt,BORDER_FULL);
			ObjText_SetFontBorderColor(objTxt,48,48,48);
			ObjText_SetFontBorderWidth(objTxt,1);
			ObjText_SetHorizontalAlignment(objTxt, ALIGNMENT_LEFT);
			ObjText_SetMaxWidth(objTxt, 900);
			Obj_SetRenderPriority(objTxt, 0.75);
			return objTxt
		}
	}
}



task StartGame_Difficulty{
	yield;
	selection = Global_LastSelection[0];
	
	let TextObjects = [];
	
	let sp = 144;
	
	let Cord = [320, 240, sp*selection];
	let objMark = CreateSelectMarker;
	ObjRender_SetPosition(objMark, Cord[0], Cord[1], 0);
	ObjRender_SetAlpha(objMark, 96);
	
	ascent(i in 0..length(DIFFICULTY_REALVAR)){
		TextObjects = TextObjects~[CreateSpriteObject(Menu_Rank)];
		ObjRender_SetPosition(TextObjects[i], Cord[0]-sp*i+Cord[2], Cord[1]+sp*i+Cord[2], 0);
		ObjSprite2D_SetSourceRect(TextObjects[i], 512, 160*i, 1023, 160*(i+1)-1);
		ObjSprite2D_SetDestCenter(TextObjects[i]);
		ObjRender_SetScaleXYZ(TextObjects[i], 0.5, 0.5, 0.5);
	}
	
	loop{
		if(GetVirtualKeyState(VK_UP)==KEY_PUSH){selection--;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_DOWN)==KEY_PUSH){selection++;PlaySound("se_select00");}
		if(selection<0){selection=5}
		if(selection>5){selection=0}
		
		ascent(i in 0..length(TextObjects)){
			let dist = GetDistanceB1(Cord[2], sp*selection);
			if(dist>1){
				Cord[2] = Cord[2]+(dist/24)*sin(atan2(sp*selection-Cord[2], Cord[0]-Cord[0]));
				}else{Cord[2] = sp*selection}
			ObjRender_SetPosition(TextObjects[i], Cord[0]+sp*i-Cord[2], Cord[1]+sp*i-Cord[2], 0);
			if(selection == i){
				ObjSprite2D_SetSourceRect(TextObjects[i], 0, 160*i, 511, 160*(i+1)-1);
			}else{
				ObjSprite2D_SetSourceRect(TextObjects[i], 512, 160*i, 1023, 160*(i+1)-1);
			}
			ObjSprite2D_SetDestCenter(TextObjects[i]);
		}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			SetCommonData("StageDiffic", -1); //remember to get rid of this 
			SetAreaCommonData("GlobalVariables", "GameDifficulty", DIFFICULTY_REALVAR[selection]);
			PlaySound("se_ok00");
			CharacterSelect(1);
			break;
		}
		if(GetVirtualKeyState(VK_BOMB)==KEY_PUSH){
			PlaySound("se_cancel00");
			MainMenu(MENU_START_GAME);
			break;
		}
		yield;
	}
	Global_LastSelection[0] = selection;
	SaveOptionsAreaData;
	ascent(i in 0..length(TextObjects)){
		Obj_Delete(TextObjects[i]);
	}
	Obj_Delete(objMark);
}

task SpellPractice{
	yield;
	
	selection = -1;
	lastselection = -1;
	selecthold = 16;
	
	let menuselect = 0; //For the scroll effect
	let pdiff = 1; // The local version of sdiff
	//----
	let DiffNames = ["Easy", "Normal", "Hard", "Lunatic", "Overdrive", "Cirno"];
	//----
	
	let TextObjects = [];
	let TextAlphas = [];
	let Cord = [96, 196];
	
	//SetSpellNames;
	ascent(i in 0..19){
		let commnt = [];
		ascent(d in 0..6){ 
			commnt = commnt~["Test Comment, spnum "~IntToString(i)~", diffnum "~IntToString(d)];
		}
		CreateSpellChoice("Testing", "", ["", "", "", "", "", ""], commnt);
	}
	
	ascent(i in 0..length(ScriptNames[1])){
		TextObjects = TextObjects~[DrawSubMenuText(ScriptNames[1][i][0])];
		TextAlphas = TextAlphas~[0];
	}
	
	let FinalBuild = [];
	let CurBuildNum = [];
	let ArrayCount = 0;
	
	
	
	let BuildText = DrawSubMenuText("Current Attack IDs:");
	ObjText_SetHorizontalAlignment(BuildText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(BuildText, 0, Cord[1]-160, 0);
	ObjText_SetMaxWidth(BuildText, 640);
	ObjText_SetFontSize(BuildText,14*Font_Sub_Modifier);
	
	let BuildNumText = DrawSubMenuText("{None}");
	ObjText_SetHorizontalAlignment(BuildNumText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(BuildNumText, Cord[0]+64, Cord[1]-144, 0);
	ObjText_SetMaxWidth(BuildNumText, 320);
	Obj_SetVisible(BuildNumText, true);
	ObjText_SetFontSize(BuildNumText,12*Font_Sub_Modifier);
	
	let StartGame = DrawSubMenuText("Return To Main Menu");
	ObjRender_SetPosition(StartGame, Cord[0], Cord[1]-80, 0);
	ObjText_SetFontSize(StartGame,16*Font_Sub_Modifier);
	ObjText_SetFontBorderColor(StartGame,24,24,24);
	
	let DifficultyText = DrawSubMenuText(DiffNames[1]);
	let DiffAlpha = 0;
	ObjText_SetHorizontalAlignment(DifficultyText, ALIGNMENT_LEFT);
	ObjRender_SetPosition(DifficultyText, Cord[0]+320, Cord[1]-84, 0);
	ObjText_SetMaxWidth(DifficultyText, 120);
	ObjText_SetFontSize(DifficultyText,24*Font_Sub_Modifier);
	
	let PatternText = DrawSubMenuText("Pattern Comment");
	ObjText_SetHorizontalAlignment(PatternText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(PatternText, 0, Cord[1]+172, 0);
	ObjText_SetMaxWidth(PatternText, 640);
	ObjText_SetFontSize(PatternText,16*Font_Sub_Modifier);
	
	let CommentText = DrawSubMenuText(DiffNames[1]);
	let CommentAlpha = 0;
	ObjText_SetHorizontalAlignment(CommentText, ALIGNMENT_CENTER);
	ObjRender_SetPosition(CommentText, 40, Cord[1]+192, 0);
	ObjText_SetMaxWidth(CommentText, 560);
	ObjText_SetFontSize(CommentText,12*Font_Sub_Modifier);
	
	EnterFromTitle(BuildText);
	EnterFromTitle(StartGame);
	EnterFromTitle(BuildNumText);
	EnterFromTitle(DifficultyText);
	EnterFromTitle(PatternText);
	EnterFromTitle(CommentText);
	UpdateCommentText;
	loop{
		if(ArrayCount>0){
			ObjText_SetText(StartGame,"Start Game");
			let bts = "";
			ascent(i in 0..length(CurBuildNum)){
				bts = bts~CurBuildNum[i];
				if(i != length(CurBuildNum)-1){
					bts = bts ~ ", ";
				}
			}
			ObjText_SetText(BuildNumText,bts);
		}else{
			ObjText_SetText(StartGame,"Return To Main Menu");
			ObjText_SetText(BuildNumText,"{None}");
		}
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], TextAlphas[i]);
			TextAlphas[i] = min(TextAlphas[i]+10, 255);
			ObjRender_SetPosition(TextObjects[i], Cord[0], Cord[1]-32+(i-menuselect)*12, 0);
			Obj_SetVisible(TextObjects[i], true);
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
				if(i-menuselect<0||i-menuselect>15){
					Obj_SetVisible(TextObjects[i], false);
				}
			}
		}
		ObjRender_SetAlpha(DifficultyText, DiffAlpha);
		DiffAlpha = min(DiffAlpha+10, 255);
		ObjRender_SetAlpha(CommentText, CommentAlpha);
		CommentAlpha = min(CommentAlpha+15, 255);
		
		if(selection==-1){
			ObjRender_SetColor(StartGame, 255, 255, 255);
		}else{
			ObjRender_SetColor(StartGame, 128, 128, 128);
		}
		
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				MenuMove(-1);
				PlaySound("se_select00");
				if(selection-menuselect<0&&menuselect>0){
					menuselect--;
				}
				if(selection<-1){
					selection = length(TextObjects)-1;
					menuselect = length(TextObjects)-min(length(TextObjects), 16);
				}
				UpdateCommentText;
			}
			selecthold--;
		}else
		if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				MenuMove(1);
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = -1;
					menuselect = 0;
				}
				if(selection-menuselect>15){
					menuselect++;
				}
				UpdateCommentText;
			}
			selecthold--;
		}else{selecthold = 16;}
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){
			pdiff--;
			if(pdiff < 0){pdiff = 5;}
			ChangeDiff;
			UpdateCommentText;
		}
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){
			pdiff++;
			if(pdiff > 5){pdiff = 0;}
			ChangeDiff;
			UpdateCommentText;
		}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			if(selection == -1){
				break;
			}
			if(ArrayCount <= 36){
				FinalBuild = FinalBuild~[ScriptIDs[selection]];
				CurBuildNum = CurBuildNum~[rtos("000", selection+1)];
				ArrayCount++;
				PlaySound("se_ok00");
			}else{
				PlaySound("se_invalid");
			}
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH){
			if(selection==-1){
				if(ArrayCount<=0){
					break;
				}
				ArrayCount--;
				//Not sure why but if I don't do it like this it errors into a type change error
				//despite doing exactly what i was doing before why
				if(length(FinalBuild)==1){
					FinalBuild = [];
					CurBuildNum = [];
				}else{
					FinalBuild = erase(FinalBuild, length(FinalBuild)-1);
					CurBuildNum = erase(CurBuildNum, length(CurBuildNum)-1);
				}
			}
			lastselection = selection;
			selection = -1;
			menuselect = 0;
			PlaySound("se_cancel00");
			if(lastselection!= -1){UpdateCommentText;}
		}
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		ReturnToTitle(TextObjects[i]);
	}
	ReturnToTitle(StartGame);
	ReturnToTitle(BuildText);
	ReturnToTitle(CommentText);
	ReturnToTitle(PatternText);
	ReturnToTitle(BuildNumText);
	ReturnToTitle(DifficultyText);
	MainMenu(MENU_START_S_PRACTICE);
	ScriptNames = [[], [], [], [], [], []];
	ScriptIDs = [];

	if(length(FinalBuild)>0){
		PlaySound("se_ok00");
		SetCommonData("ScriptBuilderData", FinalBuild);
	}else{
		PlaySound("se_cancel00");
	}
	//-------------------------------------------------------
	sub UpdateCommentText{
		CommentAlpha = 0;
		ObjRender_SetAlpha(CommentText, 0);
		
		if(selection == -1){
			FadeObjectA1(PatternText, 0, 15);
			ObjText_SetText(PatternText, "Instructions");
			ObjText_SetText(CommentText, "
In this spell practice menu, you are allowed to \"build\" a session by choosing[r]
which attack patterns you want to face. You may choose up to a maximum of [r]
40 different attacks in one session. To change the difficulty, press the left[r]
and right arrow keys. Press the select button on the spellcard to add it to the[r]
list, and press the cancel button to remove the last attack pattern.");
		}else{
			if(lastselection == -1){FadeObjectA1(PatternText, 0, 15);ObjText_SetText(PatternText, "Pattern Comment")}
			ObjText_SetText(CommentText, ScriptNames[pdiff][selection][1]);
		}
	}
	
	function ChangeDiff{
			FinalBuild = [];
			CurBuildNum = [];
			ArrayCount = 0;
			PlaySound("se_ok00");
			RedrawText;
	}
	
	task RedrawText{
		DiffAlpha = 0;
		ascent(i in 0..length(TextAlphas)){
			TextAlphas[i] = 0;
		}
		yield;
		ObjText_SetText(DifficultyText,DiffNames[pdiff]);
		alternative(pdiff)
		case(0){ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[0][i][0]);}}
		case(1){ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[1][i][0]);}}
		case(2){ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[2][i][0]);}}
		case(3){ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[3][i][0]);}}
		case(4){ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[4][i][0]);}}
		case(5){ascent(i in 0..length(TextObjects)){ObjText_SetText(TextObjects[i],ScriptNames[5][i][0]);}}
	}
}

task MusicRoom{
	yield;
	
	selection = 0;
	lastselection = 0;
	selecthold = 16;
	
	let MusicData = [
		[
		"Test Song Title 1",
		"This is the fist test song, and title song."
		],
		
		[
		"Test Song Number 2",
		"test song number two"
		],
		
		[
		"The Unmagical Library",
		"there is nothing magical about this magic library"
		],
		
		[
		"secret not unlocked song",
		"if you see this then you broke it (no im kidding)"
		],
		
		[
		"???? (dont click it or else)",
		"kogasa AHAHHAHAHHAHAHAHHAHHAHAHHAHAHAHAHHHAHAHA"
		]
		
	];
	
	let TextObjects = [];
	let TextAlphas = [];
	let Cord = [72, 180];
	
	
	ascent(i in 0..length(MusicData)){
		TextObjects = TextObjects~[DrawSubMenuText(MusicData[i][0])];
		ObjText_SetFontSize(TextObjects[i],18*Font_Sub_Modifier);
		ObjRender_SetPosition(TextObjects[i], Cord[0], Cord[1]-32+(i)*18, 0);
		TextAlphas = TextAlphas~[(i+1.35)*48];
	}
	
	let CommentAlpha = 0;
	
	let CommentTitle = DrawSubMenuText("");
	ObjText_SetHorizontalAlignment(CommentTitle, ALIGNMENT_LEFT);
	ObjRender_SetPosition(CommentTitle, 48, Cord[1]+172, 0);
	ObjText_SetMaxWidth(CommentTitle, 640);
	ObjText_SetFontSize(CommentTitle,20*Font_Sub_Modifier);
	
	let CommentText = DrawSubMenuText("");
	ObjText_SetHorizontalAlignment(CommentText, ALIGNMENT_LEFT);
	ObjRender_SetPosition(CommentText, 80, Cord[1]+200, 0);
	ObjText_SetMaxWidth(CommentText, 480);
	ObjText_SetFontSize(CommentText,14*Font_Sub_Modifier);
	
	EnterFromTitle(CommentTitle);
	EnterFromTitle(CommentText);
	
	loop{
		ascent(i in 0..length(TextObjects)){
			ObjRender_SetAlpha(TextObjects[i], max(0, TextAlphas[i]));
			TextAlphas[i] = min(TextAlphas[i]+12, 255);
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
			}
		}
		ObjRender_SetAlpha(CommentTitle, CommentAlpha);
		ObjRender_SetAlpha(CommentText, CommentAlpha);
		CommentAlpha = min(CommentAlpha+15, 255);
		
		if(GetVirtualKeyState(VK_UP)!=KEY_FREE&&GetVirtualKeyState(VK_DOWN)==KEY_FREE){
			if(GetVirtualKeyState(VK_UP) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_UP) == KEY_PUSH || selecthold == 0){
				MenuMove(-1);selecthold+=3;
				PlaySound("se_select00");
				if(selection<0){
					selection = length(TextObjects)-1;
				}
			}
			selecthold--;
		}else
		if(GetVirtualKeyState(VK_DOWN)!=KEY_FREE){
			if(GetVirtualKeyState(VK_DOWN) != KEY_HOLD){
				selecthold = 16;
			}
			if(GetVirtualKeyState(VK_DOWN) == KEY_PUSH || selecthold == 0){
				MenuMove(1);selecthold+=3;
				PlaySound("se_select00");
				if(selection>length(TextObjects)-1){
					selection = 0;
				}
			}
			selecthold--;
		}else{selecthold = 16;}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
			ObjRender_SetAlpha(CommentTitle, 0);
			ObjRender_SetAlpha(CommentText, 0);
			CommentAlpha = 0;
			ObjText_SetText(CommentTitle,MusicData[selection][0]);
			ObjText_SetText(CommentText,MusicData[selection][1]);
			PlaySound("se_ok00");
			PlayMusic(rtos("00", selection), true);
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH){
			PlaySound("se_cancel00");
			break;
		}
		yield;
	}
	ascent(i in 0..length(TextObjects)){
		ReturnToTitle(TextObjects[i]);
	}
	ReturnToTitle(CommentText);
	ReturnToTitle(CommentTitle);
	PlayMusic("00", false);
	MainMenu(MENU_MUSICROOM);
}

task SetOptionsMenu{
	yield;
	
	let selection = 0;
	let selecthold = -16;
	let selectinc = 0;
	let selectlife = [0, 0];
	let locked = false;
	let Cord = [176, 320];
	
	let TextObjects = [];
	let QualObjects = [];
	let InviObjects = [];
	let LifeObjects = [ID_INVALID, ID_INVALID];
	let BombObjects = [ID_INVALID, ID_INVALID];
		LifeObjects[0] = DrawSubMenuText("Default");
		ObjRender_SetPosition(LifeObjects[0], Cord[0]+112, Cord[1]-45, 0);
		SetDefaultTextProp(LifeObjects[0]);
		
		LifeObjects[1] = DrawSubMenuText("<< "~rtos("00", options[3])~" >>");
		ObjRender_SetPosition(LifeObjects[1], Cord[1]+112, Cord[1]-45, 0);
		SetDefaultTextProp(LifeObjects[1]);
		
		BombObjects[0] = DrawSubMenuText("Default");
		ObjRender_SetPosition(BombObjects[0], Cord[0]+112, Cord[1]-10, 0);
		SetDefaultTextProp(BombObjects[0]);
		
		BombObjects[1] = DrawSubMenuText("<< "~rtos("00", options[4])~" >>");
		ObjRender_SetPosition(BombObjects[1], Cord[1]+112, Cord[1]-10, 0);
		SetDefaultTextProp(BombObjects[1]);
		
	let TextNames = ["Volume BGM", "Volume SE", "Effects Quality", 
					"Set Lives", "Set Bombs", "Invinicbility Time", 
//					"Loading Character Info",
					"Return To Main Menu"];
					
	let Details = [
				"Sets the volume of the Background Music.",
				"Sets the volume of game Sound Effects.",
				"Sets the quality and intensity of game effects.",
				"Cheat! - Sets the starting number of lives.",
				"Cheat! - Sets the number of bombs you respawn and start with.",
				"Cheat! - Sets how long all invincibility is increased by.[r]Normal: 100%; Extend: 175%; Always: Always Invincible.",
//				"Option - Sets when how to load available player information.[r]
//				Initially: Only the first run of the game will load information (might become outdated!)[r]
//				Once: Only the first time you open the player select in one session will load information.[r]
//				Always: Everytime the player screen comes up, it will load the information.",
				"Exits the option menu. Settings will be saved."
	];
	let QualText = ["None", "Low", "Normal", "High"];
	let InviText = ["Normal", "Extend", "Always"];
	let LoadText = ["Once", "Initially", "Always"];
	ascent(i in 0..length(TextNames)){
		TextObjects = TextObjects~[DrawSubMenuText(TextNames[i])];
		let locText = TextObjects[i];
		ObjRender_SetPosition(locText, Cord[0]-90, Cord[1]-150+i*35, 0);
		SetDefaultTextProp(locText);
	}
	ascent(i in 0..length(QualText)){
		QualObjects = QualObjects~[DrawSubMenuText(QualText[i])];
		let locText = QualObjects[i];
		ObjRender_SetPosition(locText, Cord[0]+112+64*i, Cord[1]-80, 0);
		if(i == 2){ObjRender_SetPosition(locText, Cord[0]+112+57*i, Cord[1]-80, 0);}
		SetDefaultTextProp(locText);
	}
	ascent(i in 0..length(InviText)){
		InviObjects = InviObjects~[DrawSubMenuText(InviText[i])];
		let locText = InviObjects[i];
		ObjRender_SetPosition(locText, Cord[0]+112+80*i, Cord[1]+25, 0);
		SetDefaultTextProp(locText);
	}
	
	let BGM_bg = CreateBar;
	ObjRender_SetPosition(BGM_bg, Cord[0]+112, Cord[1]-140, 0);
	ObjRender_SetColor(BGM_bg, 64, 64, 64);
	let BGM = CreateBar;
	ObjRender_SetPosition(BGM, Cord[0]+112, Cord[1]-140, 0);
	ObjRender_SetColor(BGM, 112, 112, 112);
	let SE_bg = CreateBar;
	ObjRender_SetPosition(SE_bg, Cord[0]+112, Cord[1]-105, 0);
	ObjRender_SetColor(SE_bg, 64, 64, 64);
	let SE = CreateBar;
	ObjRender_SetPosition(SE, Cord[0]+112, Cord[1]-105, 0);
	ObjRender_SetColor(SE, 112, 112, 112);
	
	loop{
		if(GetVirtualKeyState(VK_UP)==KEY_PUSH&&!locked){selection--;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_DOWN)==KEY_PUSH&&!locked){selection++;PlaySound("se_select00");}
		if(selection<0){selection=6}
		if(selection>6){selection=0}
		
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH&&!locked){
			PlaySound("se_ok00");
			if(selection == 6){break;}
		}
		if(GetVirtualKeyState(VK_BOMB)==KEY_PUSH&&!locked){
			PlaySound("se_cancel00");
			if(selection == 6){break;}
			selection = 6;
		}
		
		ObjRender_SetColor(BGM, 112, 112, 112);
		ObjSprite2D_SetDestRect(BGM, 0, -4, (256/100)*options[0], 4);
		ObjRender_SetColor(SE, 112, 112, 112);
		ObjSprite2D_SetDestRect(SE, 0, -4, (256/100)*options[1], 4);
		
		alternative(selection)
		case(0){VolumeControl(0);ObjRender_SetColor(BGM, 224, 224, 224);}
		case(1){VolumeControl(1);ObjRender_SetColor(SE, 224, 224, 224);}
		case(2){QualityControl;}
		case(3){LifeBombControl(0);}
		case(4){LifeBombControl(1);}
		case(5){InvincibilityControl;}
		
		ascent(i in 0..length(TextObjects)){
			if(selection == i){
				ObjRender_SetColor(TextObjects[i], 255, 255, 255);
			}else{
				ObjRender_SetColor(TextObjects[i], 128, 128, 128);
			}
		}
		ascent(i in 0..length(QualObjects)){
			let active = 1.5;
			if(selection == 2){active = 1;}
			if(options[2] == i){
				ObjRender_SetColor(QualObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(QualObjects[i], 128/active, 128/active, 128/active);
			}
		}
		ascent(i in 0..length(LifeObjects)){
			let active = 1.5;
			if(selection == 3){active = 1;}
			if(selectlife[0] == i){
				ObjRender_SetColor(LifeObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(LifeObjects[i], 128/active, 128/active, 128/active);
			}
		}
		ascent(i in 0..length(BombObjects)){
			let active = 1.5;
			if(selection == 4){active = 1;}
			if(selectlife[1] == i){
				ObjRender_SetColor(BombObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(BombObjects[i], 128/active, 128/active, 128/active);
			}
		}
		ascent(i in 0..length(InviObjects)){
			let active = 1.5;
			if(selection == 5){active = 1;}
			if(options[5] == i){
				ObjRender_SetColor(InviObjects[i], 255/active, 255/active, 255/active);
			}else{
				ObjRender_SetColor(InviObjects[i], 128/active, 128/active, 128/active);
			}
		}
		yield;
	}
	
	SetCommonData("quality", options[2]);
	ascent(i in 0..length(TextObjects)){ReturnToTitle(TextObjects[i]);}
	ascent(i in 0..length(QualObjects)){ReturnToTitle(QualObjects[i]);}
	ascent(i in 0..length(LifeObjects)){ReturnToTitle(LifeObjects[i]);}
	ascent(i in 0..length(BombObjects)){ReturnToTitle(BombObjects[i]);}
	ascent(i in 0..length(InviObjects)){ReturnToTitle(InviObjects[i]);}
	ReturnToTitle(BGM);
	ReturnToTitle(SE);
	ReturnToTitle(BGM_bg);
	ReturnToTitle(SE_bg);
	
	SaveOptionsAreaData;
	
	MainMenu(MENU_OPTION);
	
	function SetDefaultTextProp(id){
		ObjText_SetMaxWidth(id, 300);
		Obj_SetVisible(id, true);
		ObjText_SetFontSize(id,16*Font_Sub_Modifier);
		ObjText_SetFontBorderColor(id,16,16,16);
	}
	
	function VolumeControl(num){	
		ObjSound_SetVolumeRate(CurrentBGM, options[0]);
		if(IsAllKeysFree){selecthold = -16}
		if(GetVirtualKeyState(VK_RIGHT)==KEY_FREE){
			if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH||selecthold>4){
				selecthold = 0;
				if(options[num]>0&&options[num]<100){PlaySound("se_select00");}
				if(num == 0){options[num] = max(options[num]-1-selectinc, 0);}
				if(num == 1){options[num] = max(options[num]-1-selectinc, 0);}
			}
			if(GetVirtualKeyState(VK_LEFT)==KEY_HOLD){
				selecthold++;
				selectinc+=0.025;
			}else{selecthold = -16;selectinc = 0;}
		}else{
			if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH||selecthold>4){
				selecthold = 0;
				if(options[num]>0&&options[num]<100){PlaySound("se_select00");}
				if(num == 0){options[num] = min(options[num]+1+selectinc, 100);}
				if(num == 1){options[num] = min(options[num]+1+selectinc, 100);}
			}
			if(GetVirtualKeyState(VK_RIGHT)==KEY_HOLD){
				selecthold++;
				selectinc+=0.025;
			}else{selecthold = -16;selectinc = 0;}
		}
	}
	function QualityControl{
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){options[2]=options[2]+1;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){options[2]=options[2]-1;PlaySound("se_select00");}
		if(options[2]>3){options[2] = 0;}
		if(options[2]<0){options[2] = 3;}
	}
	function InvincibilityControl{
		if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){options[5]=options[5]+1;PlaySound("se_select00");}
		if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){options[5]=options[5]-1;PlaySound("se_select00");}
		if(options[5]>2){options[5] = 0;}
		if(options[5]<0){options[5] = 2;}
	}
	function LifeBombControl(num){
		if(GetVirtualKeyState(VK_SHOT)==KEY_PUSH&&selectlife[num]==1){
			PlaySound("se_ok00");
			if(!locked){locked = true;}else{locked = false}
		}
		if(GetVirtualKeyState(VK_SPELL)==KEY_PUSH&&locked){
			PlaySound("se_cancel00");
			selectlife[num] = 0;
			locked = false;
		}
		if(num==0){ObjText_SetText(LifeObjects[1],"<< "~rtos("00", options[num+3])~" >>");}
		if(num==1){ObjText_SetText(BombObjects[1],"<< "~rtos("00", options[num+3])~" >>");}
		if(!locked){
			if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){selectlife[num]=selectlife[num]+1;PlaySound("se_select00");}
			if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH){selectlife[num]=selectlife[num]-1;PlaySound("se_select00");}
			if(selectlife[num]>1){selectlife[num] = 0;}
			if(selectlife[num]<0){selectlife[num] = 1;}
		}else{
			if(num==0){ObjText_SetText(LifeObjects[1],"<--  "~rtos("00", options[num+3])~"  -->");}
			if(num==1){ObjText_SetText(BombObjects[1],"<--  "~rtos("00", options[num+3])~"  -->");}
			if(IsAllKeysFree){selecthold = -16}
			if(GetVirtualKeyState(VK_RIGHT)==KEY_FREE){
				if(GetVirtualKeyState(VK_LEFT)==KEY_PUSH||selecthold>4){
					selecthold = 0;
					if(options[num+3]>0&&options[num+3]<100){PlaySound("se_select00");}
					if(num == 0){options[num+3] = max(options[num+3]-1-selectinc, 0);}
					if(num == 1){options[num+3] = max(options[num+3]-1-selectinc, 0);}
				}
				if(GetVirtualKeyState(VK_LEFT)==KEY_HOLD){
					selecthold++;
					selectinc+=0.025;
				}else{selecthold = -16;selectinc = 0;}
			}else{
				if(GetVirtualKeyState(VK_RIGHT)==KEY_PUSH||selecthold>4){
					selecthold = 0;
					if(options[num]>0&&options[num+3]<99){PlaySound("se_select00");}
					if(num == 0){options[num+3] = min(options[num+3]+1+selectinc, 99);}
					if(num == 1){options[num+3] = min(options[num+3]+1+selectinc, 99);}
				}
				if(GetVirtualKeyState(VK_RIGHT)==KEY_HOLD){
					selecthold++;
					selectinc+=0.025;
				}else{selecthold = -16;selectinc = 0;}
			}
		}
	}
	
	
	function CreateBar{
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.75);
		ObjPrim_SetTexture(obj, NULL);
		ObjSprite2D_SetSourceRect(obj, 0, 0, 1, 1);
		ObjSprite2D_SetDestRect(obj, 0, -4, 256, 4);
		return obj;
	}
}

task EndGame{
	yield;
	Obj_Delete(MenuBG);
	loop(29){yield;}
	ClosePackage;
}


task StartTheGame(type, player){
	ReturnToTitle(TitleBG);
	ReturnToTitle(MenuBG);
	IsStgFieldActive = true;
	yield;
	if(type == 1){RunRegularGame;}
	
	task RunRegularGame{
		InitializePackageScript(current~"Stage.txt", 0, player);
		TerminateStageScene;
		IsStgFieldActive = false;
		MainMenu(MENU_RETURN_START_GAME);
	}	
}

task QuickLaunch(path, player){
	IsStgFieldActive = true;
	yield;
	

	InitializePackageScript(path, 0, player);
	TerminateStageScene;
	IsStgFieldActive = false;
	MainMenu(MENU_RETURN_START_GAME);
	
}

function InitializePackageScript(path, stageindex, player){
	SetAreaCommonData("OptionConfig", "OptionValues", options);
	InitializeStageScene;
	SetStageIndex(stageindex);
	SetStageMainScript(path);
	SetStagePlayerScript(player[0]);
	StartStageScene;
	
	
	ObjSound_Stop(CurrentBGM);
	
	while(GetStageSceneState != STAGE_STATE_FINISHED){
		if(GetKeyState(KEY_ESCAPE)==KEY_PUSH){
			PauseMenu;
		}
		if(GetKeyState(KEY_BACK)&&DEBUG){
			TerminateStageScene;
			InitializeStageScene;
			SetStageIndex(stageindex);
			SetStageMainScript(path);
			SetStagePlayerScript(player[0]);
			StartStageScene;
		}
		yield;
	}
}

task PauseMenu{
	ClosePackage;
}

function CreateSpellChoice(owner, path, name, comment){
	let id = length(ScriptIDs)+1;
	
	ascent(i in 0..6){
		ScriptNames[i] = ScriptNames[i] ~ [[rtos("000", id)~" - ("~owner~") "~name[i], comment[i]]];
	}
	ScriptIDs = ScriptIDs~[path];
}



function LoadAvailablePlayers(forcereset){
	if(IsPlayersLoaded){return;}
	let LoadText = DrawSubMenuText("Now Loading: Available Players");
	ObjRender_SetPosition(LoadText, 56, 400, 0);
	ObjText_SetFontSize(LoadText,20*Font_Sub_Modifier);
	yield;
	GetLoadFreePlayerScriptList;
	IsPlayersLoaded=true;
	ReturnToTitleB1(LoadText, 25);
}

function SaveOptionsAreaData{
	SetAreaCommonData("OptionConfig", "Options", [options, Global_LastSelection]);
	SaveCommonDataAreaA1("OptionConfig");
}


function DrawSubMenuText(txtStr){
	let objTxt = ObjText_Create;
	ObjText_SetText(objTxt,txtStr);
	ObjText_SetFontSize(objTxt,12*Font_Sub_Modifier);
	ObjText_SetFontType(objTxt,Font_Sub_Name);
	let col = [rand(64,255), rand(64,255), rand(64,255)];
	ObjText_SetFontBorderType(objTxt,BORDER_FULL);
	ObjText_SetFontBorderColor(objTxt,48,48,48);
	ObjText_SetFontBorderWidth(objTxt,1);
	ObjText_SetHorizontalAlignment(objTxt, ALIGNMENT_LEFT);
	ObjText_SetMaxWidth(objTxt, 900);
	Obj_SetRenderPriority(objTxt, 0.75);
	return objTxt;
}

function DrawText(txtStr, txtX, txtY, txtSize, txtWidth, presetTxtColor, txtPriority){
	let SnowDrawText = ObjText_Create;
	ObjText_SetText(SnowDrawText,txtStr);
	SetTextColor;
	ObjText_SetFontSize(SnowDrawText,txtSize);
	ObjText_SetHorizontalAlignment(SnowDrawText, ALIGNMENT_LEFT);
	ObjText_SetFontBorderWidth(SnowDrawText,1);
	ObjText_SetFontBorderType(SnowDrawText,BORDER_FULL);
	ObjText_SetMaxWidth(SnowDrawText, txtWidth);
	Obj_SetRenderPriority(SnowDrawText, txtPriority);
	ObjRender_SetPosition(SnowDrawText, txtX, txtY, 0);
	
	SetTextColor;
	
	task SetTextColor{
		if(presetTxtColor=="black"){
			ObjText_SetFontColorTop(SnowDrawText,42,42,42);
			ObjText_SetFontColorBottom(SnowDrawText,42,42,42);
			ObjText_SetFontBorderColor(SnowDrawText,142,142,142);
		}
		if(presetTxtColor=="red"){
			ObjText_SetFontColorTop(SnowDrawText,175,20,111);
			ObjText_SetFontColorBottom(SnowDrawText,190,10,123);
			ObjText_SetFontBorderColor(SnowDrawText,142,142,142);
		}
		if(presetTxtColor=="blue"){
			ObjText_SetFontColorTop(SnowDrawText,20,80,175);
			ObjText_SetFontColorBottom(SnowDrawText,80,50,175);
			ObjText_SetFontBorderColor(SnowDrawText,142,142,142);
		}
		if(presetTxtColor=="white"){
			ObjText_SetFontColorTop(SnowDrawText,255,255,255);
			ObjText_SetFontColorBottom(SnowDrawText,185,185,185);
			ObjText_SetFontBorderColor(SnowDrawText,32,32,32);
		}
	}
	
	return SnowDrawText;
}


function CreateSelectMarker{
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.74);
	ObjPrim_SetTexture(obj, img_frame);
	ObjSprite2D_SetSourceRect(obj, 48, 416, 176, 464);
	ObjSprite2D_SetDestRect(obj, -128, -64, 128, 64);
	ObjRender_SetAlpha(obj, 204);
	return obj;
}

function CreateSpriteObject(path){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.74);
	ObjPrim_SetTexture(obj, path);
	return obj;
}

function CreateMenuImage(image){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.71);
	ObjPrim_SetTexture(obj, image);
	ObjSprite2D_SetSourceRect(obj, 0, 0, 640, 480);
	ObjSprite2D_SetDestRect(obj, 0, 0, 640, 480);
	ObjRender_SetPosition(obj, 0, 0, 0);
	return obj;
}

task ReturnToTitle(fadeid){
	descent(x in 0..14){
		ObjRender_SetAlpha(fadeid, 255*(x/14));
		yield;
	}
	Obj_Delete(fadeid);
}

task ReturnToTitleB1(fadeid, l){
	descent(x in 0..l){
		ObjRender_SetAlpha(fadeid, 255*(x/l));
		yield;
	}
	Obj_Delete(fadeid);
}

task EnterFromTitle(fadeid){
	ascent(x in 0..14){
		ObjRender_SetAlpha(fadeid, 255*(x/14));
		yield;
	}
}

task FadeObjectA1(objid, init, val){
	init = max(min(init+val, 255), 0);
	while(val > 0 && val < 255){
		ObjRender_SetAlpha(objid, init);
		yield;
		init = max(min(init+val, 255), 0);
	}
}

function MenuMove(inc){
	selecthold+=4;
	lastselection = selection;
	selection+=inc;
}

function SafeAssignA1(value, maxvalue){
	//Meant for array assigning from common data
	return min(value, maxvalue);
}


task LoadSoundEffects{
	CreateObjectSound("se_alert");
	CreateObjectSound("se_astralup");
	CreateObjectSound("se_big");
	CreateObjectSound("se_bonus");
	CreateObjectSound("se_bonus2");
	CreateObjectSound("se_bonus3");
	CreateObjectSound("se_bonus4");
	CreateObjectSound("se_boon00");
	CreateObjectSound("se_boon01");
	CreateObjectSound("se_border");
	CreateObjectSound("se_cancel00");
	CreateObjectSound("se_cardget");
	CreateObjectSound("se_cat00");
	CreateObjectSound("se_cat01");
	CreateObjectSound("se_ch00");
	CreateObjectSound("se_ch01");
	CreateObjectSound("se_ch02");
	CreateObjectSound("se_ch03");
	CreateObjectSound("se_changeitem");
	CreateObjectSound("se_charge00");
	CreateObjectSound("se_charge01b");
	CreateObjectSound("se_chargeup");
	CreateObjectSound("se_damage00");
	CreateObjectSound("se_damage01");
	CreateObjectSound("se_don00");
	CreateObjectSound("se_down");
	CreateObjectSound("se_enep00");
	CreateObjectSound("se_enep00_2");
	CreateObjectSound("se_enep01");
	CreateObjectSound("se_enep02");
	CreateObjectSound("se_etbreak");
	CreateObjectSound("se_eterase");
	CreateObjectSound("se_exattack");
	CreateObjectSound("se_extend");
	CreateObjectSound("se_extend2");
	CreateObjectSound("se_fault");
	CreateObjectSound("se_focus");
	CreateObjectSound("se_focusfix");
	CreateObjectSound("se_focusfix2");
	CreateObjectSound("se_focusin");
	CreateObjectSound("se_focusrot");
	CreateObjectSound("se_gosp");
	CreateObjectSound("se_graze");
	CreateObjectSound("se_gun00");
	CreateObjectSound("se_heal");
	CreateObjectSound("se_hint00");
	CreateObjectSound("se_ice");
	CreateObjectSound("se_ice2");
	CreateObjectSound("se_invalid");
	CreateObjectSound("se_item00");
	CreateObjectSound("se_item01");
	CreateObjectSound("se_kira00");
	CreateObjectSound("se_kira01");
	CreateObjectSound("se_kira02");
	CreateObjectSound("se_lazer00");
	CreateObjectSound("se_lazer01");
	CreateObjectSound("se_lazer02");
	CreateObjectSound("se_lgods1");
	CreateObjectSound("se_lgods2");
	CreateObjectSound("se_lgods3");
	CreateObjectSound("se_lgods4");
	CreateObjectSound("se_lgodsget");
	CreateObjectSound("se_life1");
	CreateObjectSound("se_msl");
	CreateObjectSound("se_msl2");
	CreateObjectSound("se_msl2b");
	CreateObjectSound("se_msl3");
	CreateObjectSound("se_nep00");
	CreateObjectSound("se_nice");
	CreateObjectSound("se_nodamage");
	CreateObjectSound("se_noise");
	CreateObjectSound("se_ok00");
	CreateObjectSound("se_ophide");
	CreateObjectSound("se_opshow");
	CreateObjectSound("se_option");
	CreateObjectSound("se_pause");
	CreateObjectSound("se_pin00");
	CreateObjectSound("se_pin01");
	CreateObjectSound("se_piyo");
	CreateObjectSound("se_playerdead");
	CreateObjectSound("se_pldead00");
	CreateObjectSound("se_pldead01");
	CreateObjectSound("se_plst00");
	CreateObjectSound("se_power0");
	CreateObjectSound("se_power1");
	CreateObjectSound("se_powerup");
	CreateObjectSound("se_select00");
	CreateObjectSound("se_shutter");
	CreateObjectSound("se_slash");
	CreateObjectSound("se_tan00");
	CreateObjectSound("se_tan01");
	CreateObjectSound("se_tan02");
	CreateObjectSound("se_timeout");
	CreateObjectSound("se_timeout2");
	CreateObjectSound("se_timestop0");
	CreateObjectSound("se_ufo");
	CreateObjectSound("se_ufoalert");
	CreateObjectSound("se_warning");
	CreateObjectSound("se_warpl");
	CreateObjectSound("se_warpr");
	CreateObjectSound("se_water");
	CreateObjectSound("se_wolf");
}


task CreateObjectSound(name){
	let objSound = ObjSound_Create;
	ObjSound_Load(objSound, FuncSrc~"sound/"~name~".wav");
	ObjSound_SetSoundDivision(objSound, SOUND_SE);
	ObjSound_SetRestartEnable(objSound, true);
	GlobalSounds = GlobalSounds~[objSound];
	GlobalSndStr = GlobalSndStr~[name];
	SetCommonData("GlobalSoundData", GlobalSounds);
	SetCommonData("GlobalSndStrData", GlobalSndStr);
}

task PlayMusic(name, force){
	if(name == CurrentBGMID&&!force){return;}
	ObjSound_Stop(CurrentBGM);
	Obj_Delete(CurrentBGM);
	loop(10){yield;}
	CurrentBGM = ObjSound_Create;
	CurrentBGMID = name;
	ObjSound_Load(CurrentBGM, current~"source/Music/"~name~".ogg");
	ObjSound_SetSoundDivision(CurrentBGM, SOUND_BGM);
	ObjSound_SetRestartEnable(CurrentBGM, true);
	ObjSound_SetVolumeRate(CurrentBGM, options[0]);
	ObjSound_SetLoopEnable(CurrentBGM, true);
	ObjSound_Play(CurrentBGM);
}

task DisplayFPS{
	return;
	let objText = ObjText_Create;
	ObjText_SetFontSize(objText, 14);
	ObjText_SetFontBold(objText, true);
	ObjText_SetFontColorTop(objText, 255, 255, 255);
	ObjText_SetFontColorBottom(objText, 160, 160, 255);
	ObjText_SetFontBorderType(objText, BORDER_FULL);
	ObjText_SetFontBorderColor(objText, 32, 32, 32);
	ObjText_SetFontBorderWidth(objText, 1);
	ObjText_SetHorizontalAlignment(objText, ALIGNMENT_RIGHT);
	ObjText_SetMaxWidth(objText, GetScreenWidth - 8);
	Obj_SetRenderPriority(objText, 1);
	ObjRender_SetX(objText, 0);
	ObjRender_SetY(objText, GetScreenHeight - 20);

	loop{
		ObjText_SetText(objText, vtos("1.2f", GetCurrentFps) ~ "fps");
		yield;
	}
}


function IsAllKeysFree{
	return GetVirtualKeyState(VK_LEFT) == KEY_FREE &&
	GetVirtualKeyState(VK_RIGHT) == KEY_FREE &&
	GetVirtualKeyState(VK_UP) == KEY_FREE &&
	GetVirtualKeyState(VK_DOWN) == KEY_FREE;
}

function GetDistanceB1(x1, x2){
	return absolute(x1-x2);
}

//dumb local{} not working at the top
